> For a complete page index, fetch https://developer.close.com/llms.txt # Create a new role POST https://api.close.com/api/v1/role/ Content-Type: application/json `visibility_user_lcf_ids` (optional) A list of Lead Custom Field IDs that define which leads user with this role can see. If the role has `view_all_leads` permission, this field should be empty. `visibility_user_lcf_behavior` (optional) Defines how lead visibility works for leads that don't have assigned users. If the role has `view_all_leads` permission, this field should be empty. - `require_assignment` - leads without assigned users are not visible to this role - `allow_unassigned` - leads without assigned users are visible to this role Reference: https://developer.close.com/api/resources/roles/create ## Authentication - `Authorization` header (basic auth, required) — Use your API key as the username and leave the password empty. - `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer `, where token is your auth token. ## Request ### Body (application/json) This endpoint expects an any. - `any` ## Response ### 201 Successful response ## Errors ### 400 Bad Request Error Bad request - `any` ### 401 Unauthorized Error Unauthorized - `any` ### 404 Not Found Error Not found - `any` ## Examples **Request** ```json { "name": "Account Manager", "permissions": [ "bulk_edit", "export" ], "visibility_user_lcf_behavior": null, "visibility_user_lcf_ids": null } ``` **Response** ```json { "editable": true, "id": "role_y6eLquXvRUdmwqi61tsmgCJUU7uGfxaRbDuLoONZL9p", "name": "Account Manager", "permissions": [ "bulk_edit", "export" ], "visibility_user_lcf_behavior": null, "visibility_user_lcf_ids": null } ``` **SDK Code** ```python import requests url = "https://api.close.com/api/v1/role/" payload = { "name": "Account Manager", "permissions": ["bulk_edit", "export"], "visibility_user_lcf_behavior": None, "visibility_user_lcf_ids": None } headers = { "Content-Type": "application/json" } response = requests.post(url, json=payload, headers=headers, auth=("", "")) print(response.json()) ``` ```javascript const url = 'https://api.close.com/api/v1/role/'; const credentials = btoa(":"); const options = { method: 'POST', headers: {Authorization: `Basic ${credentials}`, 'Content-Type': 'application/json'}, body: '{"name":"Account Manager","permissions":["bulk_edit","export"],"visibility_user_lcf_behavior":null,"visibility_user_lcf_ids":null}' }; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://api.close.com/api/v1/role/" payload := strings.NewReader("{\n \"name\": \"Account Manager\",\n \"permissions\": [\n \"bulk_edit\",\n \"export\"\n ],\n \"visibility_user_lcf_behavior\": null,\n \"visibility_user_lcf_ids\": null\n}") req, _ := http.NewRequest("POST", url, payload) req.SetBasicAuth("", "") req.Header.Add("Content-Type", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby require 'uri' require 'net/http' url = URI("https://api.close.com/api/v1/role/") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Post.new(url) request.basic_auth("", "") request["Content-Type"] = 'application/json' request.body = "{\n \"name\": \"Account Manager\",\n \"permissions\": [\n \"bulk_edit\",\n \"export\"\n ],\n \"visibility_user_lcf_behavior\": null,\n \"visibility_user_lcf_ids\": null\n}" response = http.request(request) puts response.read_body ``` ```java import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.post("https://api.close.com/api/v1/role/") .basicAuth("", "") .header("Content-Type", "application/json") .body("{\n \"name\": \"Account Manager\",\n \"permissions\": [\n \"bulk_edit\",\n \"export\"\n ],\n \"visibility_user_lcf_behavior\": null,\n \"visibility_user_lcf_ids\": null\n}") .asString(); ``` ```php request('POST', 'https://api.close.com/api/v1/role/', [ 'body' => '{ "name": "Account Manager", "permissions": [ "bulk_edit", "export" ], "visibility_user_lcf_behavior": null, "visibility_user_lcf_ids": null }', 'headers' => [ 'Content-Type' => 'application/json', ], 'auth' => ['', ''], ]); echo $response->getBody(); ``` ```csharp using RestSharp; using RestSharp.Authenticators; var client = new RestClient("https://api.close.com/api/v1/role/"); client.Authenticator = new HttpBasicAuthenticator("", ""); var request = new RestRequest(Method.POST); request.AddHeader("Content-Type", "application/json"); request.AddParameter("application/json", "{\n \"name\": \"Account Manager\",\n \"permissions\": [\n \"bulk_edit\",\n \"export\"\n ],\n \"visibility_user_lcf_behavior\": null,\n \"visibility_user_lcf_ids\": null\n}", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ```